/* Last edited on 2011-09-12 21:53:03 by stolfilocal */
/* _*_ latin-1 _*_  */
/* Bezier model of human body */
/* Coordinate axes are X = forwards, Y = right, Z = up. */

#ifndef bzb_patch_H
#define bzb_patch_H


typedef struct bzb_patch_cp_t 
  { r3_t cp[16];         /* Bzier control points. */
    bzb_texture_t *tx;   /* Texture for the patch. */
  } bzb_patch_cp_t;
  /* Parameters for a generic Bzier patch. Fields {cp[0..15]} are the
   Bzier control points, as a {4x4} array linearized by rows. */    

typedef struct bzb_patch_cquad_t 
  { r3_t cp[4];           /* Core control points. */
    bzb_texture_t *tx;    /* Texture for the patch. */
  } bzb_patch_cquad_t;
  /* Parameters for a Bzier patch in a C1 mesh. Fields {cp[0..3]} is the 
    central {2x2} array of the {4x4} Bzier control point array,
    linearized by rows. */    

#endif
