#ifndef cpk_lopt_multi_H
#define cpk_lopt_multi_H

/* Otimizao local de conjunto indep maximal - remocoes multiplas. */
/* Last edited on 2007-01-03 23:27:12 by stolfi */ 

#include <cpk_graph.h>
#include <cpk_mis.h>
#include <cpk_basic.h>

#include <bool.h>

void cpk_local_opt_multiple
  ( cpk_mis_state_t *SQ, /* Soluo corrente {S} e estruturas auxiliares. */
    int maxRem,        /* Nmero mximo de vrtice a trocar em cada tentativa. */
    int *nSM,          /* Tamanho da melhor soluo j vista. */
    int SM[],          /* {SM[0..nSM-1]}  a melhor soluo j vista. */
    double *WSM,       /* Peso total da melhor soluo {SM}. */
    bool_t verbose     /* TRUE para imprimir mensagens de diagnstico. */
  );
  /* Supe que o conjunto {S} armazenado em {SQ}  um conjunto
    independente maximal. Examina alguns outros conjuntos maximais
    {S'} derivados de {S} pela retirada de at {maxRem} vrtices e
    re-espanso gulosa para conjunto maximal; faz no mximo {maxTry}
    dessas tentativas. 
    
    As variveis {SM[0..nSM-1]} e {WSM} devem conter respectivamente 
    os vrtices e o peso total da melhor soluo j examinada at o momento.
    Elas so atualizadas sempre que o procedimento encontra uma 
    soluo {S} melhor que {SM}.
    
    O procedimento faz vrias passadas sobre o grafo, tentando todos
    os subconjuntos de {S} de tamanho {nRem = 1}, que encontra, depois
    {nRem=2}, {nRem = 3}, etc.; retorna quando uma passada completa
    sobre todos os vrtice e todos os tamanhos {nRem=1..maxRem} no
    consegue melhorar a soluo.  */

#endif
