#ifndef cpk_lopt_simple_H
#define cpk_lopt_simple_H

/* Otimizao local de conjunto indep maximal - remocoes multiplas. */
/* Last edited on 2007-01-03 23:27:18 by stolfi */ 

#include <cpk_mis.h>
#include <cpk_basic.h>

#include <bool.h>

void cpk_local_opt_simple
  ( cpk_mis_state_t *SQ, /* Soluo corrente {S} e estruturas auxiliares. */
    int *nSM,          /* Tamanho da melhor soluo j vista. */
    int SM[],          /* {SM[0..nSM-1]}  a melhor soluo j vista. */
    double *WSM,       /* Peso total da melhor soluo {SM}. */
    bool_t verbose     /* TRUE para imprimir mensagens de diagnstico. */
  );
  /* Supe que o conjunto {S} armazenado em {SQ}  um conjunto
    independente maximal. Examina alguns outros conjuntos maximais
    {S'} derivados de {S} pela retirada de um nico vrtice e
    re-expanso gulosa para conjunto maximal. 
    
    As variveis {SM[0..nSM-1]} e {WSM} devem conter respectivamente 
    os vrtices e o peso total da melhor soluo j examinada at o momento.
    Elas so atualizadas sempre que o procedimento encontra uma 
    soluo {S} melhor que {SM}.

    O procedimento faz vrias passadas sobre os vrtices de {S}, e
    retorna quando uma passada sobre todos os vrtices de {S} no
    consegue melhorar a soluo. */

#endif
