/* See {dg_tent_more.h} */
/* Last edited on 2007-10-14 09:46:22 by stolfi */

double dg_tent_func_dot
  ( dg_dim_t d,
    dg_pulse_family_t fam[],
    dg_tent_t ti,
    dg_func_t func
  )
  {
    /* Position of the tent's reference cell (indices in grid layer): */
    dg_grid_pos_t refPos[DDIM];
    dg_cell_position(DDIM, ti.cell, refPos);

    /* Position of the integration cell {C} for the {integrand} function: */
    dg_grid_pos_t cellPos[DDIM];

    /* Absolute bounds of cell {C}: */
    interval_t cellBox[DDIM]; 

    /* Work vectors for {integrand}: */
    double y[DDIM]; /* Point coords relative to the tent's reference cell. */
    double x[DDIM]; /* Absolute coordinates. */

    auto void integrand(double *z);
    void integrand(double *z, double *f)
      { /* {z} is relative to the current cell {C}. */
        int i; 
        /* Compute coordinates {y} relative to the tent's reference cell: */
        for (i = 0; i < DDIM; i++) 
          { double zi = z[i]
            y[i] = zi + (cellPos[i] - refPos[i]);
            x[i] = (1-zi)*cellBox[i][0] + zi*cellBox[i][1];
          }
        double tx = dg_tent_eval_cell_relative(DDIM, DG_PK_B, 0, 1, ti, y);
        tap_eval_function(func, DDIM, x, FDIM, f);
        for (i = 0; i < FDIM; i++) { f[i] *= t; }
      }

    int nc = dg_tent_domain_size(DDIM, DG_PK_B, 0, 1, ti);
    int ic;
    for (k = 0; k < FDIM; k++) { b.el[i*FDIM+k] = 0; }
    for (ic = 0; ic < nc; ic++)
      { 
        /* Get index and position of the cell number {ic} in the domain of {ti}: */
        dg_cell_index_t k = dg_tent_domain_cell(DDIM, DG_PK_B, 0, 1, ti, ic);
        dg_cell_position(ddim, k, cellPos);
        /* Get the cell's box in absolute coordinates: */
        dg_cell_box_root_relative(DDIM, k, cellBox);
        box_box_map(DDIM, cellBox, rootBox, cellBox);
        /* Integrate over that cell and accumulate: */
        double res[FDIM];
        gauss_integrate(DDIM, FDIM, o->gaussOrder, integrand, res);
        for (k = 0; k < FDIM; k++) { b[i*FDIM+k] += res[k]; }
      }
  }
