#ifndef udg_spline_H
#define udg_spline_H

/* Dyadic polynomial splines in one dimension */
/* Last edited on 2009-08-23 12:26:49 by stolfi */

#include <stdint.h>
#include <gspline.h>

/*
  GENERAL SPLINES
  
  We use here the definition of /mesh/, /spline/, and related concepts
  from {gspline.h}.  In particular, we use the types for /continuity order/ 
  {gspline_cont_t} and /degree/  {gspline_degree_t}.
  
  UNI-DIMENSIONAL DYADIC SPLINES
  
  A spline is /dyadic/ if its mesh {L} is a finite dyadic grid {G}.
   
  We are particularly interested in the space {S(P^g,G)^n} where {G}
  is a uni-dimensional dyadic grid; namely, the /dyadic polynomial
  splines on {G} with degree {g}/ whose values
  are vectors in {R^n}.  
  
  A spline in such a space is defined by a dyadic tree {t}, where to
  each node of {t} is associated a polynomial {t.data} of degree {g}
  from {R} to {R^n}. The polynomial is represented here by its
  Bernstein-Bzier coefficients, an array of {(g+1)n} real numbers,
  packed as a {bzpatch_t}.
  
  */

#endif
