/* See {minn_plot.h} */
/* Last edited on 2009-02-28 13:28:54 by stolfi */

#define _GNU_SOURCE
#include <math.h>
#include <assert.h>

#include <bool.h>
#include <vec.h>
#include <rn.h>
#include <jsfile.h>
#include <float_image.h>

#include <minn_plot.h>

#define Pr fprintf
#define Er stderr

void minn_plot_goal_2D
  ( char *fname, 
    minn_plot_goal_t *F,
    int n,
    double xo[],
    double xa[],
    double xb[],
    int NS
  )
  {
    int NC = 1;
    int NX = 2*NS+1;
    int NY = 2*NS+1;
    
    /* allocate the arg vector {x}: */
    double *x = double_vec_new(n).e;
    
    float_image_t *IMG = float_image_new(NC, NX, NY);
    
    int ia, ib;
    for (ia = -NS; ia <= +NS; ia++)
      { for (ib = -NS; ib <= +NS; ib++)
          { 
            double a = ((double)ia)/NS;
            double b = ((double)ib)/NS;
            rn_mix(n, a, xa, b, xb, x);
            rn_mix_in(n, 1-a-b, xo, x);
            double Fx = F(n, x);
            float_image_set_sample(IMG, 0, ia+NS, ib+NS, Fx);
          }
      }
    
    FILE *wr = open_write(fname, TRUE);
    float_image_write(wr, IMG);
    fclose(wr);
    float_image_free(IMG);
    free(x);
  }
