#ifndef minn_plot_H
#define minn_plot_H

/* Plots a minimizer's goal function in a 2D sbspace of its domain. */
/* Last edited on 2009-02-22 18:26:11 by stolfi */

#define _GNU_SOURCE
#include <stdio.h>

typedef double minn_plot_goal_t(int n, double x[]);

void minn_plot_goal_2D
  ( char *fname, 
    minn_plot_goal_t *F,
    int n,
    double xo[],
    double xa[],
    double xb[],
    int NS
  );
  /* Plots the value of {F(n,x)} for several vectors {x[0..n-1]}.
    Each vector is obtained as {xo + a*(xa-xo) + b*(xb-xo)},
    where ech parameter {a,b} assumes {2*NS+1} equally spaced 
    values in {[-1_+1]}. 
    
    The output is a file in FNI format with 1 channel
    and {2*NS+1} rows and columns. */

#endif
