/* pnm_leo.h - Some functions to do low-level I/O on PNM files. */
/* Last edited on 2008-05-25 01:41:06 by stolfi */

#ifndef pnm_leo_H
#define pnm_leo_H

#include <stdlib.h>
#include <stdio.h>
#include <sys/types.h>

#define Unknown 0x00

#define Ascii   0x80
#define Raw     0x40

#define PBM     0x01
#define PGM     0x02

typedef struct Image {
  int type;
  int width, height;
  u_char *data;
} Image;

#define GetPixel(i, x, y) (i->data[(i)->width * (y) + (x)])
#define SetPixel(i, x, y, val) (i->data[(i)->width * (y) + (x)] = val)

Image *NewImage(int width, int height);

Image *ReadPNM(char *fn);

void WritePBM(char *fn, Image *image);
void WritePGM(char *fn, Image *image);

#endif
