/* wave_leo.h */
/* Last edited on 2008-05-25 01:41:34 by stolfi */

#ifndef wave_leo_H
#define wave_leo_H

#include <pnm_leo.h>

#define MAXD 512
#define MAXL 10
#define MAXB 2000
#define BADL -1

#define MODE_SPACIAL      0
#define MODE_FREQUENCY    1
#define MODE_MIXED(bx,by) ( ((bx) & 255) | (((by) & 255) << 8) | (1<<16) )
#define MODE_MIXED_X(m)   ( (m) & 255 )
#define MODE_MIXED_Y(m)   ( ((m) >> 8) & 255 )

#define ROW 0
#define COL 1

typedef struct Gray {
  int size, level;
  float data[MAXD][MAXD];	/* expected to be [0-1] for grayscale */
} Gray;

int  SizeToLevel(int size);
int  LevelToSize(int level);

void GrayFromImage(Gray *gray, Image *image);
void GrayToImage(Gray *gray, Image *image);
void GraySetDecompMode(int mode);
void GrayDecomp(Gray *gray);
void GrayDecompToImage(Gray *gray, Image *image, float scale, int minscale);
void GrayDecompStats(Gray *gray, float scale, int minscale, 
		     int *bins, int nbins);
void GrayZeroAllButNamed(Gray *gray, int *keep, int nbins);
void GrayZeroAllSmall(Gray *gray, Gray *reference, float minsize);
void GrayRecon(Gray *gray);
void GrayCopy(Gray *src, Gray *dest);

#endif
