/* Last edited on 2009-02-09 17:48:16 by stolfi */
/* BottomUpHeapSort
   !!: doesn't  sort a[0..NUM_ELEMENTS-1] but a[1..NUM_ELEMENTS]
*/

#include <intsort_extra2.h>

int path[LOG_ELEMENTS];

inline int isrt_es_BUH_LeafSearch(int root, int treeSize) {
  int j, i=0;
  path[i++]=j=root;
  while(2*j < treeSize)  {
    if (Compare_less(a[2*j+1],a[2*j]))
      path[i++]=j=2*j;
    else
      path[i++]=j=2*j+1;
  }
  if (2*j == treeSize)
    path[i++]=j=treeSize;
  return j;
}

inline int isrt_es_BUH_BottomUpSearch(int i,int j) {
  while((j>i) && Compare_less(a[j],a[i]))
     j/=2;
     return j;
}

inline void isrt_es_BUH_Interchange(int i,int j) {
  int k,v;
 
  v = Assign(a[path[0]]);
  for(k=0;path[k]<j;k++) { 
    a[path[k]] = Assign(a[path[k+1]]);
  }
  a[path[k]] = Assign(v);
}


inline void isrt_es_BUH_ReHeap(int root,int treeSize) {
   int j;
   j = isrt_es_BUH_LeafSearch(root,treeSize);
   j = isrt_es_BUH_BottomUpSearch(root,j);
   isrt_es_BUH_Interchange(root,j);
}


void isrt_es_BUH_sort() {
  int m;

  for (m = NUM_ELEMENTS/2;m>=1;m--)
    isrt_es_BUH_ReHeap(m,NUM_ELEMENTS);

  for (m=NUM_ELEMENTS;m>=2;m--) {
    isrt_es_BUH_Swap(1,m);
    if (m != 2) isrt_es_BUH_ReHeap(1,m-1);
  }
}
