/* Last edited on 2008-05-09 10:23:23 by stolfi */
/* MDR_HeapSort
   !!: doesn't  sort a[0..NUM_ELEMENTS-1] but a[1..NUM_ELEMENTS]
*/

#include <intsort_extra2.h>

#define LEFT    2
#define RIGHT   1
#define UNKNOWN 0

int Reverse[MAX_ELEMENTS+1];
int path[LOG_ELEMENTS];


inline int isrt_es_MDR_LeafSearch(int root, int treeSize) {
  int j, i=0;
  path[i++]=j=root;
  while(2*j < treeSize) {
    if (Reverse[j] == LEFT) {
      path[i++]=j=2*j;
    }
    else if (Reverse[j] == RIGHT) { 
      path[i++]=j=2*j+1;
    }
    else if (Compare_less(a[2*j+1],a[2*j])) {     
      Reverse[j] = LEFT;
      path[i++]=j=2*j; 
    }
    else {     
      Reverse[j] = RIGHT;
      path[i++]=j=2*j+1;
    }
  }
  if (2*j == treeSize)
    path[i++]=j=treeSize;
  return j;
}


inline int isrt_es_MDR_BottomUpSearch(int i,int j) {
  while((j>i) && Compare_less(a[j],a[i]))
    j/=2;
  return j;
}

inline void isrt_es_MDR_Interchange(int i,int j) {
  int k, v = Assign(a[path[0]]);
  for(k=0;path[k]<j;k++) { 
    a[path[k]] = Assign(a[path[k+1]]);
    Reverse[path[k]] = UNKNOWN;
  }
  a[path[k]] = Assign(v);
}


inline void isrt_es_MDR_ReHeap(int root,int treeSize) {
  int j = LeafSearch(root,treeSize);
  j = BottomUpSearch(root,j);
  Interchange(root,j);
}



void isrt_es_MDR_sort() {
  int m;

  for (m = NUM_ELEMENTS/2; m>=1; m--)
    ReHeap(m,NUM_ELEMENTS);

  for (m=NUM_ELEMENTS; m>=2; m--) {
    Swap(1,m);
    if (m != 2) ReHeap(1,m-1);
  }
}

