/* Last edited on 2008-05-09 10:23:31 by stolfi */
/* Cleverquicksort, see Sedgewick "The analysis of quicksort programs",
   Acta Informatica, Journal of Algorithms, 15(1):76-100, 1993 */

#include <intsort_extra2.h>

void isrt_es_clever_quick_threesort(int left, int right) { 
  int i,j,v;
  if (right-left == 1) {
    if (Compare_less(a[right],a[left])) Swap(left,right);
  } 
  else { 
    if (right-left == 2) {
      if (Compare_less(a[left],a[left+1])) 
	if (Compare_less(a[left+1],a[right])) 
	  ;                       /* left < left+1 < right */ 
	else 
	  if (Compare_less(a[left],a[right]))
	    Swap(left+1,right);      /* left < right < left+1 */
	  else  {
	    v = Assign(a[left]);    /* right < left < left+1 */
	    a[left] = Assign(a[right]);
	    a[right] = Assign(a[left+1]);
	    a[left+1] = Assign(v);
	  }
      else
	if (Compare_less(a[right],a[left+1])) 
	  Swap(left,right);      /* right < left+1 < left */ 
	else 
	  if (Compare_less(a[left],a[right]))
	    Swap(left+1,left);      /* left+1 < left < right */
	  else  {
	    v = Assign(a[left]);    /* left+1 < right < left */
	    a[left] = Assign(a[left+1]);
	    a[left+1] = Assign(a[right]);
	    a[right] = Assign(v);
	  }
    }
  }
}

inline void isrt_es_clever_quick_insertionsort(int left, int right) { 
  int i,j,v;
  for (i = right-1; i >= left; i--) {
    if (Compare_less(a[i+1],a[i])) {
      v = Assign(a[i]); j = i+1;
      do { 
	a[j-1] = Assign(a[j]); j++; 
      } while (Compare_less(a[j],v));
      a[j-1] = Assign(v);
    }
  }
}

void isrt_es_clever_quick_cleverquicksort(int left, int right)
{ int i,j,v;

  if (right-left >= 3) {
     if (Compare_less(a[right],a[left+1])) Swap(left+1,right);
     if (Compare_less(a[right],a[left])) Swap(left,right);
     if (Compare_less(a[left],a[left+1])) Swap(left+1,left);     
     i = left+1; j = right; v = Assign(a[left]);
     do { 
       do {
         i++;
       } while (Compare_less(a[i],v));
       do {
	 j--;
       } while (Compare_less(v,a[j])); 
       if (j >= i) Swap(i,j);
     } 
     while(j >= i);
     Swap(left,j);
     if (j-left < right-i+1)
     {
       cleverquicksort(left,j-1);
       cleverquicksort(i,right);
     }
     else
     {
       cleverquicksort(i,right);
       cleverquicksort(left,j-1);
     }
  }
  else  /* insertionsort(left,right); */ 
    threesort(left,right);   
}

void isrt_es_clever_quick_Sort() {
  cleverquicksort(0,NUM_ELEMENTS-1); 
}
