/* Quick Weak Heap Sort - 

*/

int Reverse[MAX_ELEMENTS+1];
int Active[MAX_ELEMENTS]; 


inline int isrt_es_clever_quick_weak_heap_Gparent(int heapleft, int j) {
  while (((j-heapleft) & 1) == 0)
    j = heapleft+(j-heapleft)/2;
  return (heapleft+(j-heapleft)/2);
}

inline void isrt_es_clever_quick_weak_heap_MinMerge(int i, int j) {
  if (Compare_less(a[j],a[i])) {
    Swap(i,j);
    Reverse[j] = 1-Reverse[j];
  }
}

inline void isrt_es_clever_quick_weak_heap_MaxMerge(int i, int j) {
  if (Compare_less(a[i],a[j])) {
    Swap(i,j);
    Reverse[j] = 1-Reverse[j];
  }
}

inline void isrt_es_clever_quick_weak_heap_MinMergeForest(int heapleft, int m, int workleft) {
  int x=heapleft+1, temp, temp1, temp2;

  while ( (heapleft+2*(x-heapleft) + Reverse[x]) < m )
    x = heapleft + 2*(x-heapleft) + Reverse[x];
  if( Active[x] == 0 )
    x = heapleft + (x-heapleft)/2;

  //  if depth(x) == depth(m)
  temp1 = (x-heapleft);
  temp2 = (m-heapleft);
  if( (temp1&temp2) > (temp1^temp2) ) {

    temp = x;
    x = heapleft+(x-heapleft)/2;
    while( x>heapleft ) {  // kein do-while, weil Merge(1,0) nicht aufgerufen werden darf !!
      MinMerge(temp, x); 
      x = heapleft+(x-heapleft)/2; 
    }

    Swap( workleft, temp );
    Active[temp] = 0;
  }

   else {

    do {
      MinMerge(m, x); 
      x = heapleft+(x-heapleft)/2; 
    }
    while (x>heapleft);

    Swap( workleft, m );
    Active[m] = 0;
   }
}

inline void isrt_es_clever_quick_weak_heap_MaxMergeForest(int heapleft, int m, int workright) {
  int x=heapleft+1, temp, temp1, temp2;

  while ( (temp=heapleft+2*(x-heapleft) + Reverse[x]) < m )
    x = temp;
  if( Active[x] == 0 )
    x = heapleft + (x-heapleft)/2;
  
  //  if depth(x) == depth(m)
  temp1 = (x-heapleft);
  temp2 = (m-heapleft);
  if( (temp1&temp2) > (temp1^temp2) ) {

    temp = x;
    x = heapleft+(x-heapleft)/2;
    while( x>heapleft ) { // kein do-while, weil Merge(1,0) nicht aufgerufen werden darf !!
      MaxMerge(temp, x); 
      x = heapleft+(x-heapleft)/2; 
    }
    
    Swap( workright, temp );
    Active[temp] = 0;
  }
  
  else {

    do {
      MaxMerge(m, x); 
      x = heapleft+(x-heapleft)/2; 
    }
    while (x>heapleft);
    
    Swap( workright, m );
    Active[m] = 0;
  }
}


void isrt_es_clever_quick_weak_heap_external_minweakheap_sort(int heapleft, int heapright, int workleft) {

  int i;

  if( heapleft > heapright )
    return;

  for( i=heapleft; i<=heapright; i++ ) {
    Active[i] = 1;
    Reverse[i] = 0;
  }

  for (i = heapright; i >= heapleft+1; i--)  
    MinMerge( Gparent(heapleft, i), i );

  Swap( workleft, heapleft );  workleft++;;

  i = heapright;
  while( i > heapleft ) {

    for( ; (Active[i] == 0) && (i>heapleft) ; i-- ) ;

    if( i > heapleft ) {
      MinMergeForest(heapleft, i, workleft);
      workleft++;
    }
  }
}

void isrt_es_clever_quick_weak_heap_external_maxweakheap_sort(int heapleft, int heapright, int workright) {

  int i;

  if( heapleft > heapright )
    return;

  for( i=heapleft; i<=heapright; i++ ) {
    Active[i] = 1;
    Reverse[i] = 0;
  }

  for (i = heapright; i >= heapleft+  1; i--)  
    MaxMerge( Gparent(heapleft, i), i );

  Swap( workright, heapleft );  workright--;;

  i = heapright;
  while( i > heapleft ) {

    for( ; (Active[i] == 0) && (i>heapleft) ; i-- ) ;

    if( i > heapleft ) {
      MaxMergeForest(heapleft, i, workright);
      workright--;
    }
  }
}

void isrt_es_clever_quick_weak_heap_threesort(int left, int right) { 
  int i,j;
  double v;
  if (right-left == 1) {
    if (Compare_less(a[right],a[left])) Swap(left,right);
  } 
  else { 
    if (right-left == 2) {
      if (Compare_less(a[left],a[left+1])) 
        if (Compare_less(a[left+1],a[right])) 
          ;                       /* left < left+1 < right */ 
        else 
          if (Compare_less(a[left],a[right]))
            Swap(left+1,right);      /* left < right < left+1 */
          else  {
            v = Assign(a[left]);    /* right < left < left+1 */
            a[left] = Assign(a[right]);
            a[right] = Assign(a[left+1]);
            a[left+1] = Assign(v);
          }
      else
        if (Compare_less(a[right],a[left+1])) 
          Swap(left,right);      /* right < left+1 < left */ 
        else 
          if (Compare_less(a[left],a[right]))
            Swap(left+1,left);      /* left+1 < left < right */
          else  {
            v = Assign(a[left]);    /* left+1 < right < left */
            a[left] = Assign(a[left+1]);
            a[left+1] = Assign(a[right]);
            a[right] = Assign(v);
          }
    }
  }
}

void isrt_es_clever_quick_weak_heap_cleverquickweakheap(int left, int right) { 
  int i,j,v;
 
  if (right-left >= 3) {
     if (Compare_less(a[left+1],a[right])) Swap(left+1,right);
     if (Compare_less(a[left],a[right])) Swap(left,right);
     if (Compare_less(a[left+1],a[left])) Swap(left+1,left);     
     i = left+1; j = right; v = Assign(a[left]);
     do { 
       do j--; while (Compare_less(a[j],v)); 
       do i++; while (Compare_less(v,a[i]));
       if (j >= i) Swap(i,j);
     } 
     while(j >= i);
     Swap(left, right - (j-left));
     if( (j-left) >= (right-j) ){
       external_minweakheap_sort( j+1, right, left );
       left = right - (j-left) + 1;
     }
     else {
       external_maxweakheap_sort( left+1, j, right );
       right = right - (j-left + 1);
     }
     cleverquickweakheap(left,right);
  }
  else  /* insertionsort(left,right); */ 
    threesort(left,right);
}

void isrt_es_clever_quick_weak_heap_Sort() {

  cleverquickweakheap(0,NUM_ELEMENTS-1);
}
