/* Quick Weak Heap Sort - 
   
   see:
   Stefan Edelkamp: "Fast Sequential Sorting with INDEX-WEAK-HEAPSORT and QUICK-WEAK-HEAPSORT",
   somewhere, sometimes.
*/


#include <intsort_extra2.h>

int Reverse[MAX_ELEMENTS+1];
int Active[MAX_ELEMENTS]; 


inline int isrt_es_quick_weak_heap_Gparent(int heapleft, int j) {
  while (((j-heapleft) & 1) == 0)
    j = heapleft+(j-heapleft)/2;
  return (heapleft+(j-heapleft)/2);
}

inline void isrt_es_quick_weak_heap_MinMerge(int i, int j) {
  if (Compare_less(a[j],a[i])) {
    Swap(i,j);
    Reverse[j] = 1-Reverse[j];
  }
}

inline void isrt_es_quick_weak_heap_MaxMerge(int i, int j) {
  if (Compare_less(a[i],a[j])) {
    Swap(i,j);
    Reverse[j] = 1-Reverse[j];
  }
}

inline void isrt_es_quick_weak_heap_MinMergeForest(int heapleft, int m, int workleft) {
  int x=heapleft+1, temp, temp1, temp2;

  while ( (heapleft+2*(x-heapleft) + Reverse[x]) < m )
    x = heapleft + 2*(x-heapleft) + Reverse[x];
  if( Active[x] == 0 )
    x = heapleft + (x-heapleft)/2;

  //  if depth(x) == depth(m)
  temp1 = (x-heapleft);
  temp2 = (m-heapleft);
  if( (temp1&temp2) > (temp1^temp2) ) {

    temp = x;
    x = heapleft+(x-heapleft)/2;
    while( x>heapleft ) {  // kein do-while, weil Merge(1,0) nicht aufgerufen werden darf !!
      MinMerge(temp, x); 
      x = heapleft+(x-heapleft)/2; 
    }

    Swap( workleft, temp );
    Active[temp] = 0;
  }

   else {

    do {
      MinMerge(m, x); 
      x = heapleft+(x-heapleft)/2; 
    }
    while (x>heapleft);

    Swap( workleft, m );
    Active[m] = 0;
   }
}

inline void isrt_es_quick_weak_heap_MaxMergeForest(int heapleft, int m, int workright) {
  int x=heapleft+1, temp, temp1, temp2;

  while ( (temp=heapleft+2*(x-heapleft) + Reverse[x]) < m )
    x = temp;
  if( Active[x] == 0 )
    x = heapleft + (x-heapleft)/2;
  
  //  if depth(x) == depth(m)
  temp1 = (x-heapleft);
  temp2 = (m-heapleft);
  if( (temp1&temp2) > (temp1^temp2) ) {

    temp = x;
    x = heapleft+(x-heapleft)/2;
    while( x>heapleft ) { // kein do-while, weil Merge(1,0) nicht aufgerufen werden darf !!
      MaxMerge(temp, x); 
      x = heapleft+(x-heapleft)/2; 
    }
    
    Swap( workright, temp );
    Active[temp] = 0;
  }
  
  else {

    do {
      MaxMerge(m, x); 
      x = heapleft+(x-heapleft)/2; 
    }
    while (x>heapleft);
    
    Swap( workright, m );
    Active[m] = 0;
  }
}


void isrt_es_quick_weak_heap_external_minheap_sort(int heapleft, int heapright, int workleft) {

  int i;

  if( heapleft > heapright )
    return;

  for( i=heapleft; i<=heapright; i++ ) {
    Active[i] = 1;
    Reverse[i] = 0;
  }

  for (i = heapright; i >= heapleft+1; i--)  
    MinMerge( Gparent(heapleft, i), i );

  Swap( workleft, heapleft );  workleft++;;

  i = heapright;
  while( i > heapleft ) {

    for( ; (Active[i] == 0) && (i>heapleft) ; i-- ) ;

    if( i > heapleft ) {
      MinMergeForest(heapleft, i, workleft);
      workleft++;
    }
  }
}

void isrt_es_quick_weak_heap_external_maxheap_sort(int heapleft, int heapright, int workright) {

  int i;

  if( heapleft > heapright )
    return;

  for( i=heapleft; i<=heapright; i++ ) {
    Active[i] = 1;
    Reverse[i] = 0;
  }

  for (i = heapright; i >= heapleft+  1; i--)  
    MaxMerge( Gparent(heapleft, i), i );

  Swap( workright, heapleft );  workright--;;

  i = heapright;
  while( i > heapleft ) {

    for( ; (Active[i] == 0) && (i>heapleft) ; i-- ) ;

    if( i > heapleft ) {
      MaxMergeForest(heapleft, i, workright);
      workright--;
    }
  }
}


void isrt_es_quick_weak_heap_quickweakheap(int left, int right) { 
  int i,j,v;
 
  while (right-left > 0) {

    i = left; j = right+1; v=Assign(a[left]);
    do { 
      
      do {
	j--;
      } while ((j>=i) && Compare_less(a[j],v));  // a[pivot_idx+1]..a[right] < pivot
      
      do  {
	i++;
      } while ((i<=j) && Compare_lesseq(v,a[i])); // a[left]..a[pivot_idx] >= pivot
      
      if (j > i) {
	Swap(i,j); 
	//      printarray( i, j );
      }
      
    } 
    while(j >= i);
    
    Swap(left, right - (j-left));

    if( (j-left) >= (right-j) ){
      
      external_minheap_sort( j+1, right, left );
      left = right - (j-left) + 1;
    }
    
    else {
      
      external_maxheap_sort( left+1, j, right );
      right = right - (j-left) - 1;

    }
  }
}

void isrt_es_quick_weak_heap_Sort() {

  quickweakheap(0,NUM_ELEMENTS-1);
}
