/* Weak-Heapsort, see Stefan Edelkamp, "Weak-Heapsort" 
   Diplomarbeit Lehrstuhl 2, Fachbereicht Informatik, 44221 Dortmund */

#include <intsort_extra2.h>

int Reverse[MAX_ELEMENTS+1];


inline int isrt_es_whs_Gparent(int j) {
  while ((j & 1) == 0)
    j /= 2;
  return (j / 2);
}


inline void isrt_es_whs_Merge(int i, int j) {
  if (Compare_less(a[i],a[j])) {
    Swap(i,j);
    Reverse[j] = 1-Reverse[j];
  }
}

inline void isrt_es_whs_MergeForest(int m) {
  int x=1;
  while ((2*x + Reverse[x]) < m) x = 2*x + Reverse[x];
  do
     { Merge(m, x); x /= 2; }
  while (x>0);

}

inline void isrt_es_whs_weak_heap_sort() {
  int i;

  for (i = NUM_ELEMENTS - 1; i >= 1; i--)
    Merge(Gparent(i), i);

  a[NUM_ELEMENTS] = Assign(a[0]);

  for (i = NUM_ELEMENTS - 1; i >= 2; i--)
    MergeForest(i);
}

void isrt_es_whs_Sort() {
  int i;

  for ( i=0; i < NUM_ELEMENTS; i++)
    Reverse[i] = 0;

  weak_heap_sort();

  // whs sort a[0..NUM_ELEMENTS-1] to a[1..NUM_ELEMENTS]
  // we have to move the elements one position to the left
  // to be really in place
  for( i=1; i <= NUM_ELEMENTS; i++ )
    a[i-1] = Assign(a[i]);
}







