#ifndef udg_spline_H
#define udg_spline_H

/* Dyadic polynomial splines in one dimension */
/* Last edited on 2009-02-09 17:53:23 by stolfi */

#include <stdint.h>
#include <gspline.h>

/*
  GENERAL SPLINES
  
  We use here the definition of /mesh/, /spline/, and related concepts
  from {gspline.h}. */
  
typedef int8_t udg_cont_t;
  /* Continuity order of a function. The value {-1} means discontinuous.. */
  
typedef int8_t udg_degree_t;
  /* Degree of a polynomial or spline, order of a derivative, etc.. */
  
/*
  UNI-DIMENSIONAL DYADIC SPLINES
  
  A spline is /dyadic/ if its mesh {L} is a finite dyadic grid {G}.
   
  We are particularly interested in the space {S_c(P^g,G)} where {G}
  is a uni-dimensional dyadic grid; namely, the /dyadic polynomial
  splines on {G} with continuity {c} and degree {g}/. */

#endif
